#include <bits/stdc++.h>
using namespace std;

void relocate(vector<vector<char>>& pat) {
    int fi = 3, fj = 3, li = 0, lj = 0;

    for (int i = 0; i < 3; i++) {
    for (int j = 0; j < 3; j++) {
        if (pat[i][j] != '0') {
            if (i < fi) { fi = i; }
            if (j < fj) { fj = j; }
            if (i > li) { li = i; }
            if (j > lj) { lj = j; }
        }
    }
    }

    for (int i = 0; i < 3; i++) {
    for (int j = 0; j < 3; j++) {
        if (i-fi >= 0 && j-fj >= 0) {
            pat[i-fi][j-fj] = pat[i][j];
            if (!(i-fi == i && j-fj == j)) {
                pat[i][j] = '0';
            }
        }
    }
    }
}

// [0,0] [0,1] [0,2]    [2,0] [1,0] [0,0]
// [1,0] [1,1] [1,2] -> [2,1] [1,1] [0,1]
// [2,0] [2,1] [2,2]    [2,2] [1,2] [0,2]
void rotate_90(vector<vector<char>>& pat) {
    swap(pat[0][0], pat[2][0]);
    swap(pat[0][2], pat[2][0]);
    swap(pat[2][0], pat[2][2]);

    // [2,0] [0,1] [0,0]
    // [1,0] [1,1] [1,2]
    // [2,2] [2,1] [0,2]

    swap(pat[0][1], pat[1][2]);
    swap(pat[0][1], pat[1][0]);
    swap(pat[2][1], pat[1][0]);
}

vector<int> cmat (262144);

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n, m;
    cin >> n >> m;

    vector<vector<char>> mat (n, vector<char>(m));

    for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
        cin >> mat[i][j];
    }
    }

    for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
        int h = 0;

        int p = 1;
        for (int di = 0; di < 3; di++) {
        for (int dj = 0; dj < 3; dj++) {
            if (0 <= i+di && i+di < n && 0 <= j+dj && j+dj < m) {
                h += p*int(mat[i+di][j+dj]-'0');
            }
            p *= 4;
        }
        }

        cmat[h]++;
    }
    }

    int q;
    cin >> q;

    while (q--) {
        vector<vector<char>> pat (3, vector<char>(3));

        int comb = 1;
        for (int i = 0; i < 3; i++) {
        for (int j = 0; j < 3; j++) {
            cin >> pat[i][j];
            if (pat[i][j] == '0') { comb *= 4; }
        }
        }

        int c = 0;

        set<int> S;
        for (int l = 0; l < 4; l++) {
            relocate(pat);

            for (int k = 0; k < comb; k++) {
                int h = 0;

                int kk = k;
                int p = 1;
                for (int i = 0; i < 3; i++) {
                for (int j = 0; j < 3; j++) {
                    if (pat[i][j] == '0') {
                        h += p*(kk%4);
                        kk /= 4;
                    } else {
                        h += p*int(pat[i][j]-'0');
                    }
                    p *= 4;
                }
                }

                if (k == 0) {
                    if (S.count(h)) { break; }
                    S.insert(h);
                }

                c += cmat[h];
            }

            rotate_90(pat);
        }

        cout << c << "\n";
    }
}
