#include <bits/stdc++.h>
using namespace std;

void relocate(vector<vector<char>>& pat) {
    int fi = 3, fj = 3, li = 0, lj = 0;

    for (int i = 0; i < 3; i++) {
    for (int j = 0; j < 3; j++) {
        if (pat[i][j] != '0') {
            if (i < fi) { fi = i; }
            if (j < fj) { fj = j; }
            if (i > li) { li = i; }
            if (j > lj) { lj = j; }
        }
    }
    }

    for (int i = 0; i < 3; i++) {
    for (int j = 0; j < 3; j++) {
        if (i-fi >= 0 && j-fj >= 0) {
            pat[i-fi][j-fj] = pat[i][j];
            if (!(i-fi == i && j-fj == j)) {
                pat[i][j] = '0';
            }
        }
    }
    }
}

// [0,0] [0,1] [0,2]    [2,0] [1,0] [0,0]
// [1,0] [1,1] [1,2] -> [2,1] [1,1] [0,1]
// [2,0] [2,1] [2,2]    [2,2] [1,2] [0,2]
void rotate_90(vector<vector<char>>& pat) {
    swap(pat[0][0], pat[2][0]);
    swap(pat[0][2], pat[2][0]);
    swap(pat[2][0], pat[2][2]);

    // [2,0] [0,1] [0,0]
    // [1,0] [1,1] [1,2]
    // [2,2] [2,1] [0,2]

    swap(pat[0][1], pat[1][2]);
    swap(pat[0][1], pat[1][0]);
    swap(pat[2][1], pat[1][0]);
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n, m;
    cin >> n >> m;

    vector<vector<char>> mat (n, vector<char>(m));

    for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
        cin >> mat[i][j];
    }
    }

    int q;
    cin >> q;

    while (q--) {
        vector<vector<char>> pat (3, vector<char>(3));
        for (int i = 0; i < 3; i++) {
        for (int j = 0; j < 3; j++) {
            cin >> pat[i][j];
        }
        }

        set<vector<vector<char>>> pats;
        for (int l = 0; l < 4; l++) {
            relocate(pat);
            pats.insert(pat);
            rotate_90(pat);
        }

        int c = 0;
        for (auto pat : pats) {
            for (int i = -2; i < n; i++) {
            for (int j = -2; j < m; j++) {
                bool ok = true;

                for (int di = 0; di < 3 && ok; di++) {
                for (int dj = 0; dj < 3 && ok; dj++) {
                    if (pat[di][dj] != '0') {
                        if (0 <= i+di && i+di < n && 0 <= j+dj && j+dj < m) {
                            if (pat[di][dj] == mat[i+di][j+dj]) { continue; }
                        }
                        ok = false;
                    }
                }
                }

                if (ok) { c++; }
            }
            }
        }

        cout << c << "\n";
    }
}
