#include <bits/stdc++.h>
using namespace std;

int N = 1000+15;

int timestamp = 0;
vector<int> visited (N);
vector<vector<int>> G (N);
vector<vector<int>> G_t (N);
vector<int> rep (N);
stack<int> S;

void fill_stack (int u) {
    visited[u] = timestamp;
    for (int v : G[u]) if (visited[v] != timestamp) {
        fill_stack(v);
    }
    S.push(u);
}

void mark_component (int u, int my_rep) {
    visited[u] = timestamp;
    rep[u] = my_rep;
    for (int v : G_t[u]) if (visited[v] != timestamp) {
        mark_component(v, my_rep);
    }
}

queue<int> kosaraju (int n) {
    timestamp++;
    for (int u = 0; u < n; u++) if (visited[u] != timestamp) {
        fill_stack(u);
    }

    timestamp++;
    queue<int> topo_components;
    while (!S.empty()) {
        int u = S.top(); S.pop();
        if (visited[u] != timestamp) {
            mark_component(u, u);
            topo_components.push(u);
        }
    }

    return topo_components;
}

const int oo = 987654321;

int dfs (int u, int find_rep) {
    if (visited[u] == timestamp) { return oo; }
    visited[u] = timestamp;

    int b = rep[u] == find_rep ? u : oo;
    for (int v : G[u]) {
        b = min(dfs(v, find_rep), b);
    }
    return b;
}

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n, m;
    cin >> n >> m;

    vector<int> Us (n);
    vector<vector<int>> U (n, vector<int>(m));
    for (int u = 0; u < n; u++) {
        cin >> Us[u];

        for (int j = 0; j < Us[u]; j++) {
            int v;
            cin >> v;
            v--;

            U[u][v] = 1;
        }
    }

    vector<vector<int>> cnt (n, vector<int>(n, 0));

    for (int j = 0; j < m; j++) {
        for (int u = 0; u < n; u++) if (U[u][j]) {
            for (int v = 0; v < n; v++) if (U[v][j]) {
                cnt[u][v]++;
            }
        }
    }

    for (int u = 0; u < n; u++) {
        for (int v = 0; v < n; v++) if (u != v && cnt[u][v] == Us[u]) {
            G[u].push_back(v);
            G_t[v].push_back(u);
        }
    }

    queue<int> T = kosaraju(n);
    timestamp++;

    vector<int> out;

    while (!T.empty()) {
        int u = T.front(); T.pop();
        int v = dfs(u, rep[u]);
        if (v != oo) { out.push_back(v); }
    }

    sort(out.begin(), out.end());
    for (int u : out) { cout << u << "\n"; }
}
