#include "testlib.h"

using namespace std;

typedef struct {
    char digit = 0;
    bool orange;
} square;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int n = argc > 2 ? opt<int>(2) : rnd.next(1, 100);
    int m = argc > 3 ? opt<int>(3) : rnd.next(1, 100);
    cout << n << " " << m << "\n";

    vector<vector<square>> mat (n, vector<square>(m));

    int oranges = 0;
    int blues = 0;

    for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
        mat[i][j] = {
            .digit = argc > 4 ? char(opt<int>(4)) : char(rnd.next(0, 2) == 0 ? 0 : rnd.next(1, 8)),
            .orange = bool(rnd.next(0, 1))
        };
        if (mat[i][j].orange) { oranges += mat[i][j].digit; }
        if (!mat[i][j].orange) { blues += mat[i][j].digit; }
    }
    }

    while (oranges != blues) {
        int i = rnd.next(0, n-1);
        int j = rnd.next(0, m-1);

        if (oranges > blues) {
            if (mat[i][j].digit != 0 && mat[i][j].orange) {
                mat[i][j].digit--;
                oranges--;
            } else if (mat[i][j].digit != 8 && !mat[i][j].orange) {
                mat[i][j].digit++;
                blues++;
            }
        } else {
            if (mat[i][j].digit != 8 && mat[i][j].orange) {
                mat[i][j].digit++;
                oranges++;
            } else if (mat[i][j].digit != 0 && !mat[i][j].orange) {
                mat[i][j].digit--;
                blues--;
            }
        }
    }

    for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
        if (mat[i][j].digit == 0) {
            cout << "..";
        } else {
            cout << int(mat[i][j].digit) << (mat[i][j].orange ? 'a' : 'b');
        }
    }
        cout << "\n";
    }
}
