#include "testlib.h"

using namespace std;

typedef struct {
    char digit = 0;
    bool orange;
} square;

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int n = argc > 2 ? opt<int>(2) : rnd.next(1, 40);
    int m = argc > 3 ? opt<int>(3) : rnd.next(1, 40);
    cout << n << " " << m << "\n";

    int k = argc > 4 ? opt<int>(4) : rnd.next(0, n*m);

    vector<vector<square>> mat (n, vector<square>(m));
    while (k) {
        int i = rnd.next(0, n-1);
        int j = rnd.next(0, m-1);

        if (mat[i][j].digit == 8) { continue; }

        int dir = rnd.next(0, 1);

        if (dir == 0) {
            int di = rnd.next(0, n-1);
            if (di == i) { continue; }
            bool ok = true;
            if (di < i) {
                for (int ki = di; ki < i; ki++) if (mat[ki][j].digit) {
                    ok = false; break;
                }
            } else {
                for (int ki = i+1; ki <= di; ki++) if (mat[ki][j].digit) {
                    ok = false; break;
                }
            }
            if (!ok) { continue; }
            mat[di][j].digit++;
            mat[di][j].orange = !mat[i][j].orange;
        } else {
            int dj;
            dj = rnd.next(0, m-1);
            if (dj == j) { continue; }
            bool ok = true;
            if (dj < j) {
                for (int kj = dj; kj < j; kj++) if (mat[i][kj].digit) {
                    ok = false; break;
                }
            } else {
                for (int kj = j+1; kj <= dj; kj++) if (mat[i][kj].digit) {
                    ok = false; break;
                }
            }
            if (!ok) { continue; }
            mat[i][dj].digit++;
            mat[i][dj].orange = !mat[i][j].orange;
        }

        mat[i][j].digit++;

        k--;
    }

    for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
        if (mat[i][j].digit == 0) {
            cout << "..";
        } else {
            cout << int(mat[i][j].digit) << (mat[i][j].orange ? 'a' : 'b');
        }
    }
        cout << "\n";
    }
}
