#include <bits/stdc++.h>
using namespace std;

typedef struct {
    char digit = 0;
    bool orange;
} square;

#define LEFT 0
#define RIGHT 1
#define UP 2
#define DOWN 3

int main() {
    cin.tie(0);
    ios_base::sync_with_stdio(0);

    int n, m;
    cin >> n >> m;

    vector<vector<square>> grid (n, vector<square>(m));
    vector<vector<int>> by_row (n);
    vector<vector<int>> by_column (m);

    int orange_digit_count = 0;
    int blue_digit_count = 0;

    for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
        char c1, c2;
        cin >> c1 >> c2;

        if (c1 == '.') { continue; }

        by_row[i].push_back(j);
        by_column[j].push_back(i);
        grid[i][j] = {
            .digit = char(c1 - '0'),
            .orange = bool(c2 - 'a')
        };
        if (grid[i][j].orange) {
            orange_digit_count += grid[i][j].digit;
        } else {
            blue_digit_count += grid[i][j].digit;
        }
    }
    }

    if (orange_digit_count != blue_digit_count) {
        cout << "NO\n";
        return 0;
    }

    vector<vector<char>> nodes (n, vector<char>(m));

    for (int i = 0; i < n; i++) {
    for (int k = 1; k < by_row[i].size(); k++) {
        int lj = by_row[i][k-1];
        int j = by_row[i][k];

        if (grid[i][lj].orange != grid[i][j].orange) {
            nodes[i][lj] |= 1<<RIGHT;
            nodes[i][j] |= 1<<LEFT;
        }
    }
    }

    for (int j = 0; j < m; j++) {
    for (int k = 1; k < by_column[j].size(); k++) {
        int li = by_column[j][k-1];
        int i = by_column[j][k];

        if (grid[li][j].orange != grid[i][j].orange) {
            nodes[li][j] |= 1<<DOWN;
            nodes[i][j] |= 1<<UP;
        }
    }
    }

    for (int i = 0; i < n; i++) {
    for (int j = 0; j < m; j++) {
        int diff = (2*__builtin_popcount(nodes[i][j]) - grid[i][j].digit);
        if (diff < 0) { cout << "NO\n"; return 0; }
    }
    }

    cout << "YES\n";
}
