#include "testlib.h"
#include <iostream>

using namespace std;

bool is_command(char c) {
    switch (c) {
        case '>': case '<': case '+': case '-':
        case '.': case ',': case '[': case ']': return true;
        default: return false;
    }
}

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    int n = -1;
    if (argc > 2) {
        n = atoi(argv[2]);
    }
    if (n == -1) {
        n = rnd.next(1, int(1e6));
    }

    int t = 0;
    if (argc > 3) {
        t = atoi(argv[3]);
    }
    if (t == 0) {
        t = rnd.next(-4, 4);
    }

    cout << n << "\n";

    string CHARACTERS = "][+-<>,. 0123456789abcdefghijklmnopqrstuvwxyz";
    if (argc > 4) {
        CHARACTERS = "[+-<>,. 0123456789abcde]fghijklmnopqrstuvwxyz";
    }

    int opened = 0;
    char last_character = ' ';
    for (int i = 0; i < n; i++) {
        if (opened >= n-i) {
            cout << ']';
            opened--;
            continue;
        }

        char ch;
        do {
            ch = CHARACTERS[rnd.wnext(CHARACTERS.size()-1, t)];
        } while (
            (i == 0 && !is_command(ch)) ||
            (i == n-1 && ch == ' ') ||
            (ch == ']' && opened == 0) ||
            (ch == '[' && opened >= n-i-1) ||
            (ch == ' ' && last_character == ' ')
        );

        if (ch == '[') {
            opened++;
        } else if (ch == ']') {
            opened--;
        }

        cout << ch;

        last_character = ch;
    }
    cout << "\n";
}
