#include "testlib.h"

using namespace std;

int main(int argc, char* argv[]) {
    registerValidation(argc, argv);
    int N = inf.readInt(1, 1e6, "N");
    inf.readEoln();

    string S;
    inf.readLineTo(S);
    if (S.size() != N) {
        quitf(_fail, "expected length %d", N);
    }

    if (S[0] != '<' && S[0] != '>' && S[0] != '+' && S[0] != '-' &&
        S[0] != '.' && S[0] != ',' && S[0] != '[' && S[0] != ']') {
        quitf(_fail, "expected control character at start, not %c", S[0]);
    }

    int brackets = 0;

    for (int i = 0; i < N; i++) {
        if ('a' <= S[i] && S[i] <= 'z') { continue; }
        if ('0' <= S[i] && S[i] <= '9') { continue; }
        if (S[i] == ' ') { continue; }
        if (S[i] == '<' || S[i] == '>') { continue; }
        if (S[i] == '+' || S[i] == '-') { continue; }
        if (S[i] == '.' || S[i] == ',') { continue; }
        if (S[i] == '[') {
            brackets++;
            continue;
        }
        if (S[i] == ']') {
            if (brackets == 0) {
                quitf(_fail, "] not expected");
            }
            brackets--;
            continue;
        }

        quitf(_fail, "unexpected character %c", S[i]);
    }

    if (brackets != 0) {
        quitf(_fail, "expected %d ]s", brackets);
    }

    inf.readEof();
}
